--- src/include/storage/proc.h.orig	2014-08-18 14:10:37.065017690 -0400
+++ src/include/storage/proc.h	2014-08-19 16:56:14.487200038 -0400
@@ -106,6 +106,10 @@ struct PGPROC
 	uint8		lwWaitMode;		/* lwlock mode being waited for */
 	struct PGPROC *lwWaitLink;	/* next waiter for same LW lock */
 
+#if defined(USE_AIO_ATOMIC_BUILTIN_COMP_SWAP) && defined(USE_AIO_SIGEVENT)
+	struct PGPROC *BAiocbWaiterLink;	/*  chain of backends waiting for aio completion */
+#endif
+
 	/* Info about lock the process is currently waiting for, if any. */
 	/* waitLock and waitProcLock are NULL if not currently waiting. */
 	LOCK	   *waitLock;		/* Lock object we're sleeping on ... */
--- src/include/storage/smgr.h.orig	2014-08-18 14:10:37.069017709 -0400
+++ src/include/storage/smgr.h	2014-08-19 16:56:14.507200109 -0400
@@ -92,6 +92,21 @@ extern void smgrextend(SMgrRelation reln
 		   BlockNumber blocknum, char *buffer, bool skipFsync);
 extern void smgrprefetch(SMgrRelation reln, ForkNumber forknum,
 			 BlockNumber blocknum);
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+extern void smgrinitaio(int max_aio_threads, int max_aio_num);
+extern void smgrstartaio(SMgrRelation reln, ForkNumber forknum,
+			 BlockNumber blocknum , char *aiocbp , int *retcode
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on lock instead of polling */
+                                , unsigned long BAiocbaioOrdinal
+#endif /* USE_AIO_SIGEVENT  */
+                        );
+extern void smgrcompleteaio( SMgrRelation reln, char *aiocbp , int *inoutcode
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on lock instead of polling */
+                                , int (*BufAWaitAioCompletion)(char *)  /*  function to await completion if non-originator */
+                                , char *BAiocbP /* pointer to BAIOcb  */
+#endif /* USE_AIO_SIGEVENT  */
+                           );
+#endif  /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
 extern void smgrread(SMgrRelation reln, ForkNumber forknum,
 		 BlockNumber blocknum, char *buffer);
 extern void smgrwrite(SMgrRelation reln, ForkNumber forknum,
@@ -118,6 +133,20 @@ extern void mdextend(SMgrRelation reln,
 		 BlockNumber blocknum, char *buffer, bool skipFsync);
 extern void mdprefetch(SMgrRelation reln, ForkNumber forknum,
 		   BlockNumber blocknum);
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+extern void mdinitaio(int max_aio_threads, int max_aio_num);
+extern void mdstartaio(SMgrRelation reln, ForkNumber forknum, BlockNumber blocknum , char *aiocbp , int *retcode
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on lock instead of polling */
+                                , unsigned long BAiocbaioOrdinal
+#endif /* USE_AIO_SIGEVENT  */
+                      );
+extern void mdcompleteaio( char *aiocbp , int *inoutcode
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on lock instead of polling */
+                                , int (*BufAWaitAioCompletion)(char *)  /*  function to await completion if non-originator */
+                                , char *BAiocbP /* pointer to BAIOcb  */
+#endif /* USE_AIO_SIGEVENT  */
+                         );
+#endif  /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
 extern void mdread(SMgrRelation reln, ForkNumber forknum, BlockNumber blocknum,
 	   char *buffer);
 extern void mdwrite(SMgrRelation reln, ForkNumber forknum,
--- src/include/storage/fd.h.orig	2014-08-18 14:10:37.065017690 -0400
+++ src/include/storage/fd.h	2014-08-19 16:56:14.547200253 -0400
@@ -69,6 +69,20 @@ extern File PathNameOpenFile(FileName fi
 extern File OpenTemporaryFile(bool interXact);
 extern void FileClose(File file);
 extern int	FilePrefetch(File file, off_t offset, int amount);
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+extern void FileInitaio(int max_aio_threads, int max_aio_num );
+extern int  FileStartaio(File file, off_t offset, int amount , char *aiocbp
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on lock instead of polling */
+                                , unsigned long BAiocbaioOrdinal /* ordinal number of this aio in backend's sequence  */
+#endif /* USE_AIO_SIGEVENT  */
+                           );
+extern int  FileCompleteaio( char *aiocbp , int normal_wait
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on lock instead of polling */
+                                , int (*BufAWaitAioCompletion)(char *)  /*  function to await completion if non-originator */
+                                , char *BAiocbP /* pointer to BAIOcb  */
+#endif /* USE_AIO_SIGEVENT  */
+                           );
+#endif  /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
 extern int	FileRead(File file, char *buffer, int amount);
 extern int	FileWrite(File file, char *buffer, int amount);
 extern int	FileSync(File file);
--- src/include/storage/buf_internals.h.orig	2014-08-18 14:10:37.065017690 -0400
+++ src/include/storage/buf_internals.h	2014-08-19 16:56:14.579200367 -0400
@@ -22,7 +22,9 @@
 #include "storage/smgr.h"
 #include "storage/spin.h"
 #include "utils/relcache.h"
-
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+#include "aio.h"
+#endif /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
 
 /*
  * Flags for buffer descriptors
@@ -38,8 +40,23 @@
 #define BM_JUST_DIRTIED			(1 << 5)		/* dirtied since write started */
 #define BM_PIN_COUNT_WAITER		(1 << 6)		/* have waiter for sole pin */
 #define BM_CHECKPOINT_NEEDED	(1 << 7)		/* must write for checkpoint */
-#define BM_PERMANENT			(1 << 8)		/* permanent relation (not
-												 * unlogged) */
+#define BM_PERMANENT			(1 << 8)	/* permanent relation (not unlogged) */
+#define BM_AIO_IN_PROGRESS		(1 << 9)	/* aio in progress    */
+#define BM_AIO_PREFETCH_PIN_BANKED	(1 << 10)	/* pinned when prefetch issued
+                                                        ** and this pin is banked - i.e.
+                                                        ** redeemable by the next use by same task
+                                                        ** note that for any one buffer, a pin can be banked
+                                                        **      by at most one process globally,
+                                                        **      that is,   only one process may bank a pin on the buffer
+                                                        **                 and it may do so only once (may not be stacked)
+                                                        */
+
+/*********
+for asynchronous aio-read prefetching, two golden rules concerning buffer pinning and buffer-header flags must be observed:
+  R1.  a buffer marked as BM_AIO_IN_PROGRESS must be pinned by at least one backend
+  R2.  a buffer marked as BM_AIO_PREFETCH_PIN_BANKED must be pinned by the backend identified by
+               (buf->flags & BM_AIO_IN_PROGRESS) ? ( ((BAiocbAnchr->BufferAiocbs)+(FREENEXT_BAIOCB_ORIGIN - buf->freeNext))->pidOfAio : (-(buf->freeNext))
+*********/
 
 typedef bits16 BufFlags;
 
@@ -140,17 +157,87 @@ typedef struct sbufdesc
 	BufFlags	flags;			/* see bit definitions above */
 	uint16		usage_count;	/* usage counter for clock sweep code */
 	unsigned	refcount;		/* # of backends holding pins on buffer */
-	int			wait_backend_pid;		/* backend PID of pin-count waiter */
+	int		wait_backend_pid;	/*  if     flags & BM_PIN_COUNT_WAITER
+                                                **  then   backend PID of pin-count waiter
+                                                **  else   not set
+                                                */
 
 	slock_t		buf_hdr_lock;	/* protects the above fields */
-
 	int			buf_id;			/* buffer's index number (from 0) */
-	int			freeNext;		/* link in freelist chain */
+        int    	volatile	freeNext;	/* overloaded and much-abused field :
+                                                ** EITHER
+                                                **     if     >= 0
+                                                **     then   link in freelist chain
+                                                **  OR
+                                                **     if     <  0
+                                                **     then    EITHER
+                                                **             if     flags & BM_AIO_IN_PROGRESS
+                                                **             then   negative of (the index of the aiocb in the BufferAiocbs array + 3)
+                                                **             else   if flags & BM_AIO_PREFETCH_PIN_BANKED
+                                                **             then   -(pid of task that issued aio_read and pinned buffer)
+                                                **             else   one of the special values -1 or -2 listed below
+                                                */
 
 	LWLock	   *io_in_progress_lock;	/* to wait for I/O to complete */
 	LWLock	   *content_lock;	/* to lock access to buffer contents */
 } BufferDesc;
 
+/*  structures for control blocks for our implementation of async io */
+
+/*  if USE_AIO_ATOMIC_BUILTIN_COMP_SWAP is not defined,  the following struct is not put into use at runtime
+**  but it is easier to let the compiler find the definition but hide the reference to aiocb
+**  which is the only type it would not understand
+*/
+
+struct BufferAiocb {
+       struct BufferAiocb volatile * volatile BAiocbnext;  /*    next free entry or value of BAIOCB_OCCUPIED means in use  */
+       struct sbufdesc    volatile * volatile BAiocbbufh;  /*    there can be at most one BufferDesc marked BM_AIO_IN_PROGRESS
+                                                           **    and using this BufferAiocb -
+                                                           **    if there is one, BAiocbbufh points to it, else BAiocbbufh is zero
+                                                           **    NOTE  BAiocbbufh should be zero for every BufferAiocb on the free list
+                                                           */
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+       struct aiocb       volatile            BAiocbthis;  /*    the aio library's control block for one async io */
+#ifdef USE_AIO_SIGEVENT
+       struct PGPROC  volatile * BAiocbWaiterchain;        /*    chain of backends waiting for aio completion */
+       unsigned long BAiocbaioOrdinal;                     /*    ordinal of most recent aio originated by me */
+#endif  /* USE_AIO_SIGEVENT */
+#endif /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
+       int                volatile  BAiocbDependentCount;  /*    count of tasks who depend on this BufferAiocb
+                                                           **    in the sense that they are waiting for io completion.
+                                                           **    only a Dependent may move the BufferAiocb onto the freelist
+                                                           **    and only when that Dependent is the *only* Dependent (count == 1)
+                                                           **    BAiocbDependentCount is protected by bufferheader spinlock
+                                                           **    and must be updated only when that spinlock is held
+                                                           **    negative value indicates briefly locked (may not be updated)
+                                                           */
+       pid_t              volatile  pidOfAio;              /*    pid of backend who issued an aio_read using this BAiocb -
+                                                           **    this backend must have pinned the associated buffer.
+                                                           */
+};
+
+#define BAIOCB_OCCUPIED 0x75f1        /*  distinct indicator of a BufferAiocb.BAiocbnext that is NOT on free list */
+#define BAIOCB_FREE 0x7b9d            /*  distinct indicator of a BufferAiocb.BAiocbbufh that IS     on free list */
+
+struct BAiocbAnchor {                 /*  anchor for all control blocks pertaining to aio  */
+       volatile struct BufferAiocb* BufferAiocbs;          /*  aiocbs ...                   */
+       volatile struct BufferAiocb* volatile FreeBAiocbs; /* ... and their free list   */
+};
+
+/*   values for BufCheckAsync input and retcode */
+#define BUF_INTENTION_WANT 		 1  /* wants the buffer, wait for in-progress aio and then pin */
+#define BUF_INTENTION_REJECT_KEEP_PIN 	-1  /* pin already held, do not unpin */
+#define BUF_INTENTION_REJECT_OBTAIN_PIN	-2  /* obtain pin,  caller wants it for same buffer */
+#define BUF_INTENTION_REJECT_FORGET	-3  /* unpin and tell resource owner to forget */
+#define BUF_INTENTION_REJECT_NOADJUST	-4  /* unpin and call ResourceOwnerForgetBuffer */
+#define BUF_INTENTION_REJECT_UNBANK   	-5  /* unpin only if pin banked by caller */
+
+#define BUF_INTENT_RC_CHANGED_TAG	-5
+#define BUF_INTENT_RC_BADPAGE		-4
+#define BUF_INTENT_RC_INVALID_AIO	-3    /*  invalid and aio was in progress */
+#define BUF_INTENT_RC_INVALID_NO_AIO	-1    /*  invalid and no aio was in progress */
+#define BUF_INTENT_RC_VALID		 1
+
 #define BufferDescriptorGetBuffer(bdesc) ((bdesc)->buf_id + 1)
 
 /*
@@ -159,6 +246,7 @@ typedef struct sbufdesc
  */
 #define FREENEXT_END_OF_LIST	(-1)
 #define FREENEXT_NOT_IN_LIST	(-2)
+#define FREENEXT_BAIOCB_ORIGIN	(-3)
 
 /*
  * Macros for acquiring/releasing a shared buffer header's spinlock.
--- src/include/catalog/pg_am.h.orig	2014-08-18 14:10:37.049017615 -0400
+++ src/include/catalog/pg_am.h	2014-08-19 16:56:14.611200482 -0400
@@ -67,6 +67,7 @@ CATALOG(pg_am,2601)
 	regproc		amcanreturn;	/* can indexscan return IndexTuples? */
 	regproc		amcostestimate; /* estimate cost of an indexscan */
 	regproc		amoptions;		/* parse AM-specific parameters */
+	regproc		ampeeknexttuple;	/* peek at the next tuple different from any blocknum in pfch_list without reading a new index page */
 } FormData_pg_am;
 
 /* ----------------
@@ -117,19 +118,19 @@ typedef FormData_pg_am *Form_pg_am;
  * ----------------
  */
 
-DATA(insert OID = 403 (  btree		5 2 t f t t t t t t f t t 0 btinsert btbeginscan btgettuple btgetbitmap btrescan btendscan btmarkpos btrestrpos btbuild btbuildempty btbulkdelete btvacuumcleanup btcanreturn btcostestimate btoptions ));
+DATA(insert OID = 403 (  btree		5 2 t f t t t t t t f t t 0 btinsert btbeginscan btgettuple btgetbitmap btrescan btendscan btmarkpos btrestrpos btbuild btbuildempty btbulkdelete btvacuumcleanup btcanreturn btcostestimate btoptions btpeeknexttuple ));
 DESCR("b-tree index access method");
 #define BTREE_AM_OID 403
-DATA(insert OID = 405 (  hash		1 1 f f t f f f f f f f f 23 hashinsert hashbeginscan hashgettuple hashgetbitmap hashrescan hashendscan hashmarkpos hashrestrpos hashbuild hashbuildempty hashbulkdelete hashvacuumcleanup - hashcostestimate hashoptions ));
+DATA(insert OID = 405 (  hash		1 1 f f t f f f f f f f f 23 hashinsert hashbeginscan hashgettuple hashgetbitmap hashrescan hashendscan hashmarkpos hashrestrpos hashbuild hashbuildempty hashbulkdelete hashvacuumcleanup - hashcostestimate hashoptions - ));
 DESCR("hash index access method");
 #define HASH_AM_OID 405
-DATA(insert OID = 783 (  gist		0 8 f t f f t t f t t t f 0 gistinsert gistbeginscan gistgettuple gistgetbitmap gistrescan gistendscan gistmarkpos gistrestrpos gistbuild gistbuildempty gistbulkdelete gistvacuumcleanup - gistcostestimate gistoptions ));
+DATA(insert OID = 783 (  gist		0 8 f t f f t t f t t t f 0 gistinsert gistbeginscan gistgettuple gistgetbitmap gistrescan gistendscan gistmarkpos gistrestrpos gistbuild gistbuildempty gistbulkdelete gistvacuumcleanup - gistcostestimate gistoptions - ));
 DESCR("GiST index access method");
 #define GIST_AM_OID 783
-DATA(insert OID = 2742 (  gin		0 6 f f f f t t f f t f f 0 gininsert ginbeginscan - gingetbitmap ginrescan ginendscan ginmarkpos ginrestrpos ginbuild ginbuildempty ginbulkdelete ginvacuumcleanup - gincostestimate ginoptions ));
+DATA(insert OID = 2742 (  gin		0 6 f f f f t t f f t f f 0 gininsert ginbeginscan - gingetbitmap ginrescan ginendscan ginmarkpos ginrestrpos ginbuild ginbuildempty ginbulkdelete ginvacuumcleanup - gincostestimate ginoptions - ));
 DESCR("GIN index access method");
 #define GIN_AM_OID 2742
-DATA(insert OID = 4000 (  spgist	0 5 f f f f f t f t f f f 0 spginsert spgbeginscan spggettuple spggetbitmap spgrescan spgendscan spgmarkpos spgrestrpos spgbuild spgbuildempty spgbulkdelete spgvacuumcleanup spgcanreturn spgcostestimate spgoptions ));
+DATA(insert OID = 4000 (  spgist	0 5 f f f f f t f t f f f 0 spginsert spgbeginscan spggettuple spggetbitmap spgrescan spgendscan spgmarkpos spgrestrpos spgbuild spgbuildempty spgbulkdelete spgvacuumcleanup spgcanreturn spgcostestimate spgoptions - ));
 DESCR("SP-GiST index access method");
 #define SPGIST_AM_OID 4000
 
--- src/include/catalog/pg_proc.h.orig	2014-08-18 14:10:37.053017634 -0400
+++ src/include/catalog/pg_proc.h	2014-08-19 16:56:14.667200683 -0400
@@ -536,6 +536,12 @@ DESCR("convert float4 to int4");
 
 DATA(insert OID = 330 (  btgettuple		   PGNSP PGUID 12 1 0 0 0 f f f f t f v 2 0 16 "2281 2281" _null_ _null_ _null_ _null_	btgettuple _null_ _null_ _null_ ));
 DESCR("btree(internal)");
+
+#ifndef AVOID_CATALOG_MIGRATION_FOR_ASYNCIO
+DATA(insert OID = 3256 (  btpeeknexttuple	   PGNSP PGUID 12 1 0 0 0 f f f f t f v 1 0 16 "2281" _null_ _null_ _null_ _null_ btpeeknexttuple _null_ _null_ _null_ ));
+DESCR("btree(internal)");
+#endif /* not AVOID_CATALOG_MIGRATION_FOR_ASYNCIO */
+
 DATA(insert OID = 636 (  btgetbitmap	   PGNSP PGUID 12 1 0 0 0 f f f f t f v 2 0 20 "2281 2281" _null_ _null_ _null_ _null_	btgetbitmap _null_ _null_ _null_ ));
 DESCR("btree(internal)");
 DATA(insert OID = 331 (  btinsert		   PGNSP PGUID 12 1 0 0 0 f f f f t f v 6 0 16 "2281 2281 2281 2281 2281 2281" _null_ _null_ _null_ _null_	btinsert _null_ _null_ _null_ ));
--- src/include/pg_config_manual.h.orig	2014-08-18 14:10:37.061017672 -0400
+++ src/include/pg_config_manual.h	2014-08-19 16:56:14.723200883 -0400
@@ -138,9 +138,11 @@
 /*
  * USE_PREFETCH code should be compiled only if we have a way to implement
  * prefetching.  (This is decoupled from USE_POSIX_FADVISE because there
- * might in future be support for alternative low-level prefetch APIs.)
+ * might in future be support for alternative low-level prefetch APIs  --
+ * -- update October 2013  -- now there is such a new prefetch capability --
+ *   async_io into postgres buffers  -   configuration parameter max_async_io_threads)
  */
-#ifdef USE_POSIX_FADVISE
+#if defined(USE_POSIX_FADVISE) || defined(USE_AIO_ATOMIC_BUILTIN_COMP_SWAP)
 #define USE_PREFETCH
 #endif
 
--- src/include/access/nbtree.h.orig	2014-08-18 14:10:37.045017596 -0400
+++ src/include/access/nbtree.h	2014-08-19 16:56:14.759201013 -0400
@@ -19,6 +19,7 @@
 #include "access/sdir.h"
 #include "access/xlog.h"
 #include "access/xlogutils.h"
+#include "access/relscan.h"
 #include "catalog/pg_index.h"
 
 /* There's room for a 16-bit vacuum cycle ID in BTPageOpaqueData */
@@ -524,6 +525,7 @@ typedef struct BTScanPosData
 	Buffer		buf;			/* if valid, the buffer is pinned */
 
 	BlockNumber nextPage;		/* page's right link when we scanned it */
+	BlockNumber prevPage;		/* page's left link when we scanned it */
 
 	/*
 	 * moreLeft and moreRight track whether we think there may be matching
@@ -603,6 +605,15 @@ typedef struct BTScanOpaqueData
 	 */
 	int			markItemIndex;	/* itemIndex, or -1 if not valid */
 
+	/* prefetch logic state */
+	unsigned int	backSeqRun;	/* number of back-sequential pages in a run */
+	BlockNumber		backSeqPos;	/* blkid last prefetched in back-sequential 
+				          		   runs */
+	BlockNumber		lastHeapPrefetchBlkno;	/* blkid last prefetched from heap */
+	int				prefetchItemIndex; /* item index within currPos last
+					                      fetched by heap prefetch */
+	int				prefetchBlockCount; /* number of prefetched heap blocks */
+	
 	/* keep these last in struct for efficiency */
 	BTScanPosData currPos;		/* current position data */
 	BTScanPosData markPos;		/* marked position, if any */
@@ -655,7 +666,17 @@ extern Buffer _bt_getroot(Relation rel,
 extern Buffer _bt_gettrueroot(Relation rel);
 extern int	_bt_getrootheight(Relation rel);
 extern void _bt_checkpage(Relation rel, Buffer buf);
-extern Buffer _bt_getbuf(Relation rel, BlockNumber blkno, int access);
+extern Buffer _bt_getbuf(Relation rel, BlockNumber blkno, int access
+#ifdef USE_PREFETCH
+                                      , struct pfch_index_pagelist* pfch_index_page_list
+#endif /* USE_PREFETCH */
+                         );
+#ifdef USE_PREFETCH
+extern void _bt_prefetchbuf(Relation rel, BlockNumber blkno , struct pfch_index_pagelist** pfch_index_page_list_P);
+extern struct pfch_index_item* _bt_find_block(BlockNumber blkno , struct pfch_index_pagelist* pfch_index_page_list);
+extern int _bt_add_block(BlockNumber blkno , struct pfch_index_pagelist** pfch_index_page_list_P , uint32 discard_status);
+extern void _bt_subtract_block(BlockNumber blkno , struct pfch_index_pagelist* pfch_index_page_list);
+#endif /* USE_PREFETCH */
 extern Buffer _bt_relandgetbuf(Relation rel, Buffer obuf,
 				 BlockNumber blkno, int access);
 extern void _bt_relbuf(Relation rel, Buffer buf);
--- src/include/access/heapam.h.orig	2014-08-18 14:10:37.045017596 -0400
+++ src/include/access/heapam.h	2014-08-19 16:56:14.787201113 -0400
@@ -175,7 +175,7 @@ extern void heap_page_prune_execute(Buff
 extern void heap_get_root_tuples(Page page, OffsetNumber *root_offsets);
 
 /* in heap/syncscan.c */
-extern void ss_report_location(Relation rel, BlockNumber location);
+extern void ss_report_location(Relation rel, BlockNumber location , BlockNumber *prefetchHWMp);
 extern BlockNumber ss_get_location(Relation rel, BlockNumber relnblocks);
 extern void SyncScanShmemInit(void);
 extern Size SyncScanShmemSize(void);
--- src/include/access/relscan.h.orig	2014-08-18 14:10:37.049017615 -0400
+++ src/include/access/relscan.h	2014-08-19 16:56:14.823201242 -0400
@@ -44,6 +44,24 @@ typedef struct HeapScanDescData
 	bool		rs_inited;		/* false = scan not init'd yet */
 	HeapTupleData rs_ctup;		/* current tuple in scan, if any */
 	BlockNumber rs_cblock;		/* current block # in scan, if any */
+#ifdef USE_PREFETCH
+	int	    rs_prefetch_target; /* target distance (numblocks) for prefetch to reach beyond main scan */
+	BlockNumber rs_pfchblock;	/* next block # to be prefetched in scan, if any */
+
+        /*   Unread_Pfetched is a "mostly" circular list of recently prefetched blocknos of size target_prefetch_pages
+        **   the index of the first unread block is held in Unread_Pfetched_next
+        **         and is advanced when a block is read
+        **   the count of number of unread blocks is in Unread_Pfetched_count (and this subset can wrap around)
+        **   "mostly" means that there may be gaps caused by storing entries for blocks which do not need to be discarded -
+        **   these are indicated by blockno = InvalidBlockNumber,  and these slots are reused when found.
+        */
+        BlockNumber *rs_Unread_Pfetched_base;   /*  where the list of prefetched but unread blocknos starts */
+        unsigned int rs_Unread_Pfetched_next;   /*  where the next unread blockno probably is relative to start --
+                                                **  this is only a hint which may be temporarily stale.
+                                                */
+        unsigned int rs_Unread_Pfetched_count;  /*  number of valid unread blocknos in list */
+#endif   /* USE_PREFETCH */
+
 	Buffer		rs_cbuf;		/* current buffer in scan, if any */
 	/* NB: if rs_cbuf is not InvalidBuffer, we hold a pin on that buffer */
 	ItemPointerData rs_mctid;	/* marked scan position, if any */
@@ -55,6 +73,27 @@ typedef struct HeapScanDescData
 	OffsetNumber rs_vistuples[MaxHeapTuplesPerPage];	/* their offsets */
 }	HeapScanDescData;
 
+/* pfch_index_items track prefetched and unread index pages -   chunks of blocknumbers are chained in singly-linked list from scan->pfch_index_item_list */
+struct pfch_index_item {                              /*  index-relation BlockIds which we will/have prefetched */
+       BlockNumber         pfch_blocknum;    /* Blocknum which we will/have prefetched */
+       uint32              pfch_discard;     /* whether block is to be discarded when scan is closed */
+};
+
+struct pfch_block_item {
+       struct BlockIdData  pfch_blockid;     /* BlockId which we will/have prefetched */
+       uint32              pfch_discard;     /* whether block is to be discarded when scan is closed */
+};
+
+/* pfch_index_page_items track prefetched and unread index pages -
+** chunks of blocknumbers are chained backwards (newest first,  oldest last)
+** in singly-linked list from scan->pfch_index_item_list
+*/
+struct pfch_index_pagelist {                          /*  index-relation BlockIds which we will/have prefetched */
+       struct pfch_index_pagelist* pfch_index_pagelist_next;  /*  pointer to next chunk if any */
+       unsigned int    pfch_index_item_count;         /*  number of used entries in this chunk */
+       struct pfch_index_item pfch_indexid[1];        /*  in-line list of Blocknums which we will/have prefetched and whether to be discarded */
+};
+
 /*
  * We use the same IndexScanDescData structure for both amgettuple-based
  * and amgetbitmap-based index scans.  Some fields are only relevant in
@@ -75,8 +114,15 @@ typedef struct IndexScanDescData
 	/* signaling to index AM about killing index tuples */
 	bool		kill_prior_tuple;		/* last-returned tuple is dead */
 	bool		ignore_killed_tuples;	/* do not return killed entries */
-	bool		xactStartedInRecovery;	/* prevents killing/seeing killed
-										 * tuples */
+	bool		xactStartedInRecovery;	/* prevents killing/seeing killed tuples */
+										 
+#ifdef USE_PREFETCH
+        struct pfch_index_pagelist* pfch_index_page_list;  /* array of index-relation BlockIds which we will/have prefetched */
+        struct pfch_block_item* pfch_block_item_list;   /* array of heap-relation BlockIds which we will/have prefetched */
+        unsigned short int     pfch_used;	/*  number of used elements in BlockIdData array   */
+        unsigned short int     pfch_next;	/*  next element for prefetch in BlockIdData array */
+	int             do_prefetch;    /*  should I prefetch ? */
+#endif   /* USE_PREFETCH */
 
 	/* index access method's private state */
 	void	   *opaque;			/* access-method-specific info */
@@ -91,6 +137,10 @@ typedef struct IndexScanDescData
 	/* NB: if xs_cbuf is not InvalidBuffer, we hold a pin on that buffer */
 	bool		xs_recheck;		/* T means scan keys must be rechecked */
 
+	/* heap fetch statistics for read-ahead logic */
+	unsigned int heap_tids_seen;
+	unsigned int heap_tids_fetched;
+
 	/* state data for traversing HOT chains in index_getnext */
 	bool		xs_continue_hot;	/* T if must keep walking HOT chain */
 }	IndexScanDescData;
--- src/include/nodes/tidbitmap.h.orig	2014-08-18 14:10:37.061017672 -0400
+++ src/include/nodes/tidbitmap.h	2014-08-19 16:56:14.863201385 -0400
@@ -41,6 +41,16 @@ typedef struct
 	int			ntuples;		/* -1 indicates lossy result */
 	bool		recheck;		/* should the tuples be rechecked? */
 	/* Note: recheck is always true if ntuples < 0 */
+#ifdef USE_PREFETCH
+        /*   Unread_Pfetched is a circular list of recently prefetched blocknos of size target_prefetch_pages
+        **   the index of the first unread block is held in Unread_Pfetched_next
+        **         and is advanced when a block is read
+        **   the count of number of unread blocks is in Unread_Pfetched_count (and this subset can wrap around)
+        */
+        BlockNumber *Unread_Pfetched_base;   /*  where the list of prefetched but unread blocknos starts */
+        unsigned int Unread_Pfetched_next;   /*  where the next unread blockno is relative to start */
+        unsigned int Unread_Pfetched_count;  /*  number of valid unread blocknos in list */
+#endif   /* USE_PREFETCH */
 	OffsetNumber offsets[1];	/* VARIABLE LENGTH ARRAY */
 } TBMIterateResult;				/* VARIABLE LENGTH STRUCT */
 
@@ -62,5 +72,8 @@ extern bool tbm_is_empty(const TIDBitmap
 extern TBMIterator *tbm_begin_iterate(TIDBitmap *tbm);
 extern TBMIterateResult *tbm_iterate(TBMIterator *iterator);
 extern void tbm_end_iterate(TBMIterator *iterator);
-
+extern void tbm_zero(TBMIterator *iterator); /* zero list of prefetched and unread blocknos */
+extern void tbm_add(TBMIterator *iterator, BlockNumber blockno); /* add this blockno to list of prefetched and unread blocknos */
+extern void tbm_subtract(TBMIterator *iterator, BlockNumber blockno); /* remove this blockno from list of prefetched and unread blocknos */
+extern TBMIterateResult *tbm_locate_IterateResult(TBMIterator *iterator); /* locate the TBMIterateResult of an iterator */
 #endif   /* TIDBITMAP_H */
--- src/include/utils/rel.h.orig	2014-08-18 14:10:37.069017709 -0400
+++ src/include/utils/rel.h	2014-08-19 16:56:14.891201485 -0400
@@ -61,6 +61,7 @@ typedef struct RelationAmInfo
 	FmgrInfo	ammarkpos;
 	FmgrInfo	amrestrpos;
 	FmgrInfo	amcanreturn;
+	FmgrInfo	ampeeknexttuple;	/* peek at the next tuple different from any blocknum in pfch_list without reading a new index page */
 } RelationAmInfo;
 
 
--- src/include/pg_config.h.in.orig	2014-08-18 14:10:37.061017672 -0400
+++ src/include/pg_config.h.in	2014-08-19 16:56:14.915201571 -0400
@@ -1,4 +1,4 @@
-/* src/include/pg_config.h.in.  Generated from configure.in by autoheader.  */
+/* src/include/pg_config.h.in.  Generated from - by autoheader.  */
 
 /* Define to the type of arg 1 of 'accept' */
 #undef ACCEPT_TYPE_ARG1
@@ -747,6 +747,10 @@
 /* Define to the appropriate snprintf format for unsigned 64-bit ints. */
 #undef UINT64_FORMAT
 
+/* Define to select librt-style async io and the gcc atomic compare_and_swap.
+   */
+#undef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+
 /* Define to 1 to build with assertion checks. (--enable-cassert) */
 #undef USE_ASSERT_CHECKING
 
